Apache C++ Standard Library Reference Guide

## max_element()

Library: Algorithms

    Function

- Local Index
- Summary
- Synopsis
- Description
- Complexity
- Example
- See Also
- Standards Conformance

### Local Index

No Entries

### Summary

An algorithm that finds the maximum value in a range

### Synopsis

    #include <algorithm>

    namespace std {
      template <class ForwardIterator>
      ForwardIterator
      max_element(ForwardIterator start, ForwardIterator finish);

      template <class ForwardIterator, class Compare>
      ForwardIterator
      max_element(ForwardIterator start, ForwardIterator finish,
                  Compare comp);
    }

### Description

The `max_element()` algorithm returns an iterator that denotes the maximum element in a sequence. If the sequence contains more than one copy of the element, the iterator points to its first occurrence. The optional argument `comp` defines a function object that can be used in place of `operator<()`.

Algorithm `max_element()` returns the first iterator `i` in the range `[start, finish)` such that for any iterator `j` in the same range either of the following conditions hold:

`!(*i < *j)`

or

`comp(*i, *j) == false.`

### Complexity

Exactly `max((finish - start) - 1, 0)` applications of the corresponding comparisons are done for `max_element()`.

### Example

    //
    //  max_elem.cpp
    //

    #include <algorithm>    // for max_element
    #include <functional>   // for less
    #include <iostream>     // for cout, endl
    #include <vector>       // for vector

    int main ()
    {
        typedef std::vector<int, std::allocator<int> > Vector;
        typedef Vector::iterator                       Iterator;

        const Vector::value_type d1[] = { 1, 3, 5, 32, 64 };
        // Set up vector.
        Vector v1(d1 + 0, d1 + sizeof d1 / sizeof *d1);

        // Find the largest element in the vector.
        Iterator it1 = std::max_element (v1.begin(), v1.end());

        // Find the largest element in the range from
        // the beginning of the vector to the 2nd to last.
        Iterator it2 = std::max_element (v1.begin(), v1.end() - 1,
                                         std::less<int>());

        // Find the smallest element.
        Iterator it3 = std::min_element (v1.begin(), v1.end());

        // Find the smallest value in the range from
        // the beginning of the vector plus 1 to the end.
        Iterator it4 = std::min_element (v1.begin() + 1, v1.end(),
                                         std::less<int>());

        std::cout << *it1 << " " << *it2 << " "
                  << *it3 << " " << *it4 << std::endl;

        return 0;
    }

    Program Output:

    64 32 1 3

### See Also

`max()`, `min()`, `min_element()`

### Standards Conformance

ISO/IEC 14882:1998 -- International Standard for Information Systems -- Programming Language C++, Section 25.3.7